/*
 * misc.c, part of e
 * read COPYING now for more important info.
 *
 * some miscellaneous functions...
 */


#include <ctype.h>
#include "e.h"


char *seekchar( char *in, char c )
{
	while( in[0] && in[0] != c ) in++;
	
	return in;
}


char *seekalpha( char *in )
{
	while( in[0] && !isalpha( in[0] ) ) in++;

	return in;
}


char *seeknextline( char *in )
{
	while( in[0] ) {
		if( in[0] == '\n' ) return in++;
		else in++;
	}
	
	return in;
}


char *stripspaces( char *in )
{
	while( in[0] == '\t' || in[0] == ' ' ) in++;
	
	return in;
}


void toeol( char *dest, char *src, int size )
{
	int		i;
	
	for( i = 0; i < size; i++ ) {
		dest[i] = src[i];
		if( !src[i] || src[i] == '\n' ) break;
	}
	dest[i] = 0;
}


/*
 * reads the current line to memory if it's on disk, otherwise does nothing
 *
 * returns: 0 on error, 1 on success
 */
int readlinetomem( void )
{
	STR_LINE	*l;
	
	if( !( l = e->curwin->curline ) ) return 0;

	if( !l->bufpos ) return 1;
	else if( l->bufpos == 1 ) {
		l->maxsize = ( (int) ( ( l->size + 1 ) / ALLOC_SIZE ) + 1 ) * ALLOC_SIZE;
		if( !( l->buf = (char *) e_alloc( l->maxsize ) ) )
			return 0;
		fseek( e->curwin->file->orig, l->offset, SEEK_SET );
		fgets( l->buf, l->size + 1, e->curwin->file->orig );
		l->bufpos = 0;
	} else if( l->bufpos == 2 ) {
		e_msg( "swapping doesn't really exist. You should NOT get this msg!" );
		return 0;
	}
	
	return 1;
}
